#include "stdafx.h"
#include "CommonFunc.h" 
#include "JGLBase.h"
#include "FuncGrid3D.h"
#include "Geometry.h"
#include <math.h>

#define N 150
#define PI 3.1415

QuadFrenel(float a,float b)
{   int i,j;
	float array[N][N];
	for(i=0;i<N;i++)
    for(j=0;j<N;j++)
	{   
		float x=-5+10.0*i/(float)N;
		float y=-5+10.0*j/(float)N;
		float h1,h2;
           
		if(-0.00001<x&&x<0.00001)
		  h1=1;
		else
	 	  h1=sin(3.14*x/a)/(3.14*x/a);
          
		if(-0.00001<y&&y<0.00001)
		  h2=1;
		else
		  h2=sin(3.14*y/b)/(3.14*y/b);
    	array[i][j]=h1*h1*h2*h2;
	}
	FuncGrid3D((float*)array,N,N,-2,-2,2,2,1);
}

CircleFrenel()
{   int i,j;
	float array[N][N];
	float Standar[N];
	for(i=0;i<N;i++)
	{	float x=-5+10.0*i/(float)N;
		float h1;
		if(-0.0000001<x&&x<0.0000001)
		  h1=1.0;
		else
		  h1=sin(3.14*x)/(3.14*x);
    	Standar[i]=h1*h1;
	}
	for(i=0;i<N;i++)
    for(j=0;j<N;j++)
	{
		int r=(int)sqrt((i-N/2)*(i-N/2)+(j-N/2)*(j-N/2));
		if(r<N)
   		  array[i][j]=Standar[r+N/2];
     
	}
	FuncGrid3D((float*)array,N,N,-2,-2,2,2,1);

}

JNewtonCircle(CVector center,int count,float rx)
{
	for(float i=0;i<count;i+=0.01)
		{
			float color=sin(i*2*PI);
			glColor3f(color,color,color);
		    float r=i*rx/count;
            JCircleXY(center,r);
		}
}

JParallelLines(CVector leftbottom,int count,float rx)
{
	for(float i=0;i<count;i+=0.01)
		{
			float color=sin(i*2*PI);
			glColor3f(color,color,color);
		    float location=i*rx/count;
			JLine(leftbottom.V.x+location,leftbottom.V.y+1,leftbottom.V.z,leftbottom.V.x+location,leftbottom.V.y,leftbottom.V.z);		 
		}
}