#include "stdafx.h"
#include "JGLBase.h"
#include "Climax.h"
#include "Ellipse.h"
#include "Geometry.h"
#include <math.h>



#define PI  3.1415926
	
J_EllipseArray(float* Datax,float* Datay,int ni,float a,float b)
{
	float Theta;
	int i;
	float Step=2*PI/(ni-1);     
	for(Theta=0,i=0;i<ni;Theta+=Step,i++)
	{
		Datax[i]=a*cos(Theta);
		Datay[i]=b*sin(Theta);
	}
//	Datax[ni-1]=a;            
//	Datay[ni-1]=0;
 
}

J_EllipseSphere(float A,float B,float C)
{   
    #define NX   30               
    #define NY   30               
    CClimax*  m_Climax[NX][NY];   
    float DataX[NX],DataY[NX];    
    float a,b,c;
    float StepC=2*C/(NY-1);      
    int i,j;
    for(c=-C,i=0;i<NY;c+=StepC,i++)
	{    
		a=sqrt(A*A*(1-(c/C)*(c/C)));
		b=sqrt(B*B*(1-(c/C)*(c/C)));
		J_EllipseArray(DataX,DataY,NX,a,b);
            
		for(j=0;j<NX;j++)
		   m_Climax[j][i]=new CClimax(CVector(DataX[j],DataY[j],c),CVector(1,1,1));
	}
    
	for(i=1;i<NY-1;i++)
	for(j=1;j<NX-1;j++)
	   m_Climax[j][i]->V=GetNormal(m_Climax[j][i]->L,
                                       m_Climax[j][i-1]->L,
				       m_Climax[j+1][i]->L,
				       m_Climax[j][i+1]->L,
				       m_Climax[j-1][i]->L
             					   );

	for(i=0;i<NY;i++)
        {       m_Climax[0][i]->V=m_Climax[1][i]->V;
		m_Climax[NX-1][i]->V=m_Climax[0][i]->V;
	}
	for(j=0;j<NX;j++)
	{       m_Climax[j][0]->V=CVector(0,0,-1);
		m_Climax[j][NY-1]->V=CVector(0,0,1);
	}
	
  
	for(i=0;i<NY-1;i++)
	for(j=0;j<NX-1;j++)
	{
		glBegin(GL_POLYGON);
		m_Climax[j][i]->Apply();
		m_Climax[j+1][i]->Apply();
		m_Climax[j+1][i+1]->Apply();
		m_Climax[j][i+1]->Apply();
		glEnd();
	}
	//ͷڴ
    for(i=0;i<NX;i++)
    for(j=0;j<NY;j++)
		delete m_Climax[i][j];
}


J_EllipseCutFace(float A,float B,float C,CVector V,float &Long,float &Short)
{   
    #define NX   200               
    #define NY   200               
    float DataX[NX],DataY[NX];    
    float a,b,c;
	float StepC=2*C/(NY-1);       
	int i,j;
	CVector LongAxis(0,0,0),ShortAxis(1000,1000,1000);  
	for(c=-C,i=0;i<NY;c+=StepC,i++)
	{   
		a=sqrt(A*A*(1-(c/C)*(c/C)));
		b=sqrt(B*B*(1-(c/C)*(c/C)));
		J_EllipseArray(DataX,DataY,NX,a,b);
		for(int j=0;j<NX;j++)
		{   CVector* point=new CVector(DataX[j],DataY[j],c);
		
		    float t=(*point)*V;
			
			if(t<0.01&&t>-0.01)
			{
			 if(point->GetMagnitude()>LongAxis.GetMagnitude())
			      LongAxis=*point;
			 if(point->GetMagnitude()<ShortAxis.GetMagnitude())
				  ShortAxis=*point;
			                     
			
			 glDisable(GL_LIGHTING);
		         glColor3f(1,0.5,0);
			 glBegin(GL_POINTS);
			 glVertex3f(point->V.x,point->V.y,point->V.z);
			 glEnd();
			 glEnable(GL_LIGHTING);
			 }
			delete point;
		}

	}
   
	Long=LongAxis.GetMagnitude();
	Short=ShortAxis.GetMagnitude();
}
J_EllipseSphere3Plane(float A,float B,float C)
{
     glColor3f(1,0,0);
     JFillEllipse(CVector(0,0,0),A,B,XY);
     glColor3f(0,1,0);
     JFillEllipse(CVector(0,0,0),B,C,YZ);
     glColor3f(0,0,1);
     JFillEllipse(CVector(0,0,0),A,C,XZ);
}



