#include "stdafx.h"
#include "PolarizeLight.h"
#include "Geometry.h"
#include <math.h>
#define  PI 3.1415

CPolarizeLightXZ::CPolarizeLightXZ(CVector start,float direction,float length,float wavelen,float theta,float a1,float a2,float loop)
{
	m_Start=start;
        m_Angle=direction;
        m_Length=length;
	m_WaveLen=wavelen;
	m_Theta=theta;
	m_Theta=m_Theta*PI/180.0;              
	m_A1=a1;
	m_A2=a2;
	m_LoopCount=loop;
	m_Direction=CVector(cos(PI*m_Angle/180.0),0,sin(PI*m_Angle/180.0)); 
	m_Direction.Normalize();

	m_AnimatePhase=0;
    
}
CPolarizeLightXZ::CPolarizeLightXZ(CVector start,CVector end,float wavelen,float theta,float a1,float a2,float loop)
{
	m_Start=start;
	m_End=end;
	m_WaveLen=wavelen;
	m_Theta=theta;
	m_Theta=m_Theta*PI/180.0;              
	m_A1=a1;
	m_A2=a2;
	m_LoopCount=loop;
        m_Direction=m_End-m_Start;
	m_Length=(m_End-m_Start).GetMagnitude();
	m_Direction.Normalize();

	m_AnimatePhase=0;

}
CPolarizeLightXZ::Display()
{       int  m_light;
	glGetIntegerv(GL_LIGHTING,&m_light);
	glDisable(GL_LIGHTING);
    
	m_AnimatePhase+=0.5;                   
    

	CVector V1(0,1,0);                       
	CVector V2=V1.x(m_Direction);              
	V2.Normalize();
        float m_Step=m_Length/m_LoopCount;
	CVector old=m_Start;
	for(int i=0;i<m_LoopCount;i++)
	{float phase=2*PI*i*m_Step/m_WaveLen;
	 CVector V=V1*(sin(-m_AnimatePhase+phase+m_Theta)*m_A1)+V2*(sin(-m_AnimatePhase+phase)*m_A2);
	 CVector Base=m_Start+m_Direction*(i*m_Step);
	 JLine(Base,V+Base);
	 JLine(old,V+Base);
	 old=V+Base;
	}
	
	if(m_light==GL_TRUE)
           glEnable(GL_LIGHTING);	
}

CPolarizeLightXZ::SetPhase(float theta)
{	m_Theta=theta;
	m_Theta=m_Theta*PI/180.0;              
}
